Index: platforms/iOS/vm/Common/Classes/sqSqueakScreenAndWindow.m
===================================================================
--- platforms/iOS/vm/Common/Classes/sqSqueakScreenAndWindow.m	(revision 3687)
+++ platforms/iOS/vm/Common/Classes/sqSqueakScreenAndWindow.m	(working copy)
@@ -88,11 +88,11 @@
 	sqInt w, h;
 	
 #if BUILD_FOR_OSX
-		NSRect screenSize = [gDelegateApp.mainView bounds];
+		NSRect
 #else
-		CGRect screenSize = [gDelegateApp.mainView bounds];
+		CGRect
 #endif
-		
+    screenSize = [gDelegateApp.mainView sqScreenSize];
 		w = (sqInt) screenSize.size.width;
 		h = (sqInt) screenSize.size.height;
 
Index: platforms/iOS/vm/OSX/Squeak-Info.plist
===================================================================
--- platforms/iOS/vm/OSX/Squeak-Info.plist	(revision 3687)
+++ platforms/iOS/vm/OSX/Squeak-Info.plist	(working copy)
@@ -375,6 +375,8 @@
 	<string>MainMenu</string>
 	<key>NSPrincipalClass</key>
 	<string>SqueakOSXApplication</string>
+	<key>NSHighResolutionCapable</key>
+	<false/>
 	<key>UTExportedTypeDeclarations</key>
 	<array>
 		<dict>
Index: platforms/iOS/vm/OSX/sqSqueakOSXApplication+events.m
===================================================================
--- platforms/iOS/vm/OSX/sqSqueakOSXApplication+events.m	(revision 3687)
+++ platforms/iOS/vm/OSX/sqSqueakOSXApplication+events.m	(working copy)
@@ -260,9 +260,8 @@
 	evt.type = EventTypeMouse;
 	evt.timeStamp = ioMSecs();
 
-	NSPoint local_point = [aView convertPoint: [theEvent locationInWindow] fromView:nil];
-
-	evt.x = local_point.x; 
+	NSPoint local_point = [aView sqMousePosition: theEvent];
+	evt.x = local_point.x;
 	evt.y = local_point.y;
 
 	int buttonAndModifiers = [self mapMouseAndModifierStateToSqueakBits: theEvent];
Index: platforms/iOS/vm/OSX/sqSqueakOSXApplication.m
===================================================================
--- platforms/iOS/vm/OSX/sqSqueakOSXApplication.m	(revision 3687)
+++ platforms/iOS/vm/OSX/sqSqueakOSXApplication.m	(working copy)
@@ -158,6 +158,9 @@
 		if ([argData compare:  @"-psn_" options: NSLiteralSearch range: NSMakeRange(0,5)] == NSOrderedSame) {
 			return 1;
 		}
+		if ([argData isEqualToString: @"-NSDocumentRevisionsDebugMode"]) {
+			return 1;
+		}
 	NS_HANDLER;
 	NS_ENDHANDLER;
 
Index: platforms/iOS/vm/OSX/sqSqueakOSXCGView.h
===================================================================
--- platforms/iOS/vm/OSX/sqSqueakOSXCGView.h	(revision 3687)
+++ platforms/iOS/vm/OSX/sqSqueakOSXCGView.h	(working copy)
@@ -80,13 +80,13 @@
 //Accessing
 -(NSString*)dragFileNameStringAtIndex:(sqInt) index;
 -(void) ioSetFullScreen: (sqInt) fullScreen;
--(void)fadeOut;
--(void)fadeIn;
 -(void) drawImageUsingClip: (CGRect) clip;
 -(NSUInteger)countNumberOfNoneSqueakImageFilesInDraggedFiles: (id<NSDraggingInfo>)info;
 -(NSMutableArray *)filterOutSqueakImageFilesFromDraggedFiles: (id<NSDraggingInfo>)info;
 -(NSMutableArray *)filterSqueakImageFilesFromDraggedFiles: (id<NSDraggingInfo>)info;
 -(void) drawThelayers;
+- (NSRect) sqScreenSize;
+- (NSPoint) sqMousePosition: (NSEvent*)theEvent;
 @end
 
 #import	"SqViewClut.h"
Index: platforms/iOS/vm/OSX/sqSqueakOSXCGView.m
===================================================================
--- platforms/iOS/vm/OSX/sqSqueakOSXCGView.m	(revision 3687)
+++ platforms/iOS/vm/OSX/sqSqueakOSXCGView.m	(working copy)
@@ -48,15 +48,10 @@
 #import "sqVirtualMachine.h"
 
 #import <QuartzCore/QuartzCore.h>
-#import <QuartzCore/CIImage.h>
 
-//#import <OpenGL/CGLMacro.h>
-
 extern SqueakOSXAppDelegate *gDelegateApp;
 extern struct	VirtualMachine* interpreterProxy;
 
-#define max(x, y) (x > y? x: y)
-
 static NSString *stringWithCharacter(unichar character) {
 	return [NSString stringWithCharacters: &character length: 1];
 }
@@ -65,17 +60,6 @@
 @synthesize squeakTrackingRectForCursor,lastSeenKeyBoardStrokeDetails,
 lastSeenKeyBoardModifierDetails,dragInProgress,dragCount,dragItems,windowLogic,savedScreenBoundsAtTimeOfFullScreen;
 
-+ (NSOpenGLPixelFormat *)defaultPixelFormat {
-	NSOpenGLPixelFormatAttribute attrs[] =
-    {
-		NSOpenGLPFAAccelerated,
-		NSOpenGLPFANoRecovery,
-		NSOpenGLPFABackingStore,
-		0
-    };
-    return AUTORELEASEOBJ([[NSOpenGLPixelFormat alloc] initWithAttributes:attrs]);
-}
-
 - (id)initWithFrame:(NSRect)frameRect {
     self = [super initWithFrame:frameRect];
 
@@ -88,8 +72,6 @@
 }
 
 - (void)awakeFromNib {
-	//self = [self initWithFrame: self.frame pixelFormat: [[self class] defaultPixelFormat] ];
-//    self = [self initWithFrame: self.frame];
     [self initialize];
 }
 
@@ -128,6 +110,21 @@
 	return YES;
 }
 
+- (NSRect) sqScreenSize {
+  return [self convertRectToBacking: [self bounds]];
+}
+
+
+- (NSPoint) sqMousePosition: (NSEvent*)theEvent {
+	/* Our client expects the mouse coordinates in Squeak's coordinates,
+	 * but theEvent's location is in "user" coords. so we have to convert. */
+	NSPoint local_pt = [self convertPoint: [theEvent locationInWindow] fromView:nil];
+	NSPoint converted = [self convertPointToBacking: local_pt];
+	// Squeak is upside down
+	return NSMakePoint(converted.x, -converted.y);
+}
+
+
 - (void)viewDidMoveToWindow {
 	if (self.squeakTrackingRectForCursor)
 		[self removeTrackingRect: self.squeakTrackingRectForCursor];
@@ -194,7 +191,16 @@
 - (void) performDraw: (CGRect)rect {
 	sqInt form = interpreterProxy->displayObject(); // Form
 
-    CGContextRef context = (CGContextRef)[[NSGraphicsContext currentContext] graphicsPort];
+    CGContextRef context;
+#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1010 && defined(NSFoundationVersionNumber10_10)
+    if (floor(NSFoundationVersionNumber) >= NSFoundationVersionNumber10_10) {
+        context = [[NSGraphicsContext currentContext] CGContext];
+    } else { // Deprecated in OSX 10.10
+        context = (CGContextRef)[[NSGraphicsContext currentContext] graphicsPort];
+    }
+#else
+    context = (CGContextRef)[[NSGraphicsContext currentContext] graphicsPort];
+#endif
     CGContextSaveGState(context);
     
     int width = interpreterProxy->positive32BitValueOf(interpreterProxy->fetchPointerofObject(1, form));
@@ -203,43 +209,65 @@
 	void* bits = (void*)interpreterProxy->firstIndexableField(formBits); // bits
     int bitSize = interpreterProxy->byteSizeOf(formBits);
     int bytePerRow = 4*width;
-    
-    CGRect r = NSRectToCGRect([self frame]);
-    int y2 = max(r.size.height - (rect.origin.y), 0);
-    int y1 = max(y2 - rect.size.height, 0);
-    
-    CGRect swapRect = CGRectIntersection(CGRectMake(0, 0, width, height), CGRectMake(rect.origin.x, y1, rect.size.width, y2));
-    [self swapColors: bits imageWidth:width clipRect: swapRect];
-    
-    CGDataProviderRef pref = CGDataProviderCreateWithData (NULL, bits, bitSize, NULL);
-    CGContextTranslateCTM(context, 0, height);
-    CGContextScaleCTM(context, 1, -1);
-    CGImageRef image = CGImageCreate(width, 
-                                     height, 
-                                     8, 
-                                     32, 
-                                     bytePerRow, 
-                                     colorspace, 
-                                     kCGBitmapByteOrder32Big | kCGImageAlphaLast, 
-                                     pref, 
-                                     NULL, 
-                                     NO, 
-                                     kCGRenderingIntentDefault);
-    
-    CGContextClipToRect(context,rect);
-    CGContextDrawImage(context, CGRectMake(0, 0, width, height), image);
 
-    [self swapColors:bits imageWidth:width clipRect: swapRect];
-    
-    CGImageRelease(image);
-    CGDataProviderRelease(pref);
-    
+
+	CGAffineTransform  deviceTransform = CGContextGetUserSpaceToDeviceSpaceTransform(context);
+
+	CGFloat frameHeight = [self frame].size.height * deviceTransform.d;
+    CGFloat y2 = MAX(frameHeight - rect.origin.y, 0);
+    CGFloat y1 = MAX(y2 - rect.size.height, 0);
+
+	CGRect swapRect = CGRectIntersection(CGRectMake(0, 0, width, height), CGRectMake(rect.origin.x, y1, rect.size.width, y2));
+	if (!CGRectIsNull(swapRect)) {
+		[self swapColors: bits imageWidth:width clipRect: swapRect];
+
+		CGDataProviderRef pref = CGDataProviderCreateWithData (NULL, bits, bitSize, NULL);
+		CGImageRef image = CGImageCreate(width,
+										 height,
+										 8,
+										 32,
+										 bytePerRow,
+										 colorspace,
+										 kCGBitmapByteOrder32Big | kCGImageAlphaLast,
+										 pref,
+										 NULL,
+										 NO,
+										 kCGRenderingIntentDefault);
+
+		CGRect userClipRect = CGRectMake(rect.origin.x / deviceTransform.a,
+										 rect.origin.y / deviceTransform.d,
+										 rect.size.width / deviceTransform.a,
+										 rect.size.height / deviceTransform.d);
+
+
+		CGContextTranslateCTM(context, 0, height / deviceTransform.d);
+		CGContextScaleCTM(context, 1 , -1);
+
+
+		CGContextClipToRect(context, userClipRect);
+
+		CGRect imageBounds = CGContextConvertRectToUserSpace(context, CGRectMake(deviceTransform.tx, deviceTransform.ty, width, height));
+
+		CGContextDrawImage(context, imageBounds, image);
+
+		[self swapColors:bits imageWidth:width clipRect: swapRect];
+
+	    CGImageRelease(image);
+		CGDataProviderRelease(pref);
+	}
     CGContextRestoreGState(context);
 }
 
 -(void)drawRect:(NSRect)rect
 {
-    [self performDraw:(clippyIsEmpty? NSRectToCGRect(rect):clippy)];
+	CGRect rectToDraw;
+	if (clippyIsEmpty) {
+		NSSize backingSize = [self convertRectToBacking:rect].size;
+		rectToDraw = CGRectMake(0, 0, backingSize.width, backingSize.height);
+	} else {
+		rectToDraw = clippy;
+	}
+	[self performDraw: rectToDraw];
     clippyIsEmpty = YES;
     syncNeeded = NO;
 }
@@ -634,6 +662,8 @@
 	if ([self isInFullScreenMode] == NO && (fullScreen == 1)) {
 		self.savedScreenBoundsAtTimeOfFullScreen = (NSRect) [self bounds];
 		NSDictionary* options = [NSDictionary dictionaryWithObjectsAndKeys:
+			[NSNumber numberWithBool:NO],
+			NSFullScreenModeAllScreens,
 			[NSNumber numberWithInt:
 				NSApplicationPresentationHideDock |
 				NSApplicationPresentationHideMenuBar ],
Index: platforms/iOS/vm/OSX/sqSqueakOSXOpenGLView.h
===================================================================
--- platforms/iOS/vm/OSX/sqSqueakOSXOpenGLView.h	(revision 3687)
+++ platforms/iOS/vm/OSX/sqSqueakOSXOpenGLView.h	(working copy)
@@ -75,8 +75,6 @@
 - (void) fakeKeyDownUp: (NSEvent*) theEvent;
 - (NSString*) dragFileNameStringAtIndex:(sqInt) index;
 - (void)  ioSetFullScreen: (sqInt) fullScreen;
-- (void)fadeOut;
-- (void)fadeIn;
 - (void) drawImageUsingClip: (CGRect) clip;
 - (NSUInteger) countNumberOfNoneSqueakImageFilesInDraggedFiles: (id<NSDraggingInfo>)info;
 - (NSMutableArray *) filterOutSqueakImageFilesFromDraggedFiles: (id<NSDraggingInfo>)info;
@@ -84,6 +82,8 @@
 -(void)setupOpenGL;
 - (void) drawThelayers;
 - (void) preDrawThelayers;
+- (NSRect) sqScreenSize;
+- (NSPoint) sqMousePosition: (NSEvent*)theEvent;
 @end
 
 #import	"SqViewClut.h"
Index: platforms/iOS/vm/OSX/sqSqueakOSXOpenGLView.m
===================================================================
--- platforms/iOS/vm/OSX/sqSqueakOSXOpenGLView.m	(revision 3687)
+++ platforms/iOS/vm/OSX/sqSqueakOSXOpenGLView.m	(working copy)
@@ -89,6 +89,7 @@
 }
 
 - (void)initialize {
+	[self setWantsBestResolutionOpenGLSurface:YES];
 	inputMark = NSMakeRange(NSNotFound, 0);
 	inputSelection = NSMakeRange(0, 0);
     [self registerForDraggedTypes: [NSArray arrayWithObjects: NSFilenamesPboardType, nil]];
@@ -104,6 +105,9 @@
 - (void) initializeVariables {
 }
 
+- (void) preDrawThelayers {
+}
+
 - (void) dealloc {
 	free(colorMap32);
 	CGColorSpaceRelease(colorspace);
@@ -122,17 +126,32 @@
 	return YES;
 }
 
+- (NSRect) sqScreenSize {
+  return [self convertRectToBacking: [self bounds]];
+}
+
+
+- (NSPoint) sqMousePosition: (NSEvent*)theEvent {
+	/* Our client expects the mouse coordinates in Squeak's coordinates,
+	 * but theEvent's location is in "user" coords. so we have to convert. */
+	NSPoint local_pt = [self convertPoint: [theEvent locationInWindow] fromView:nil];
+	NSPoint converted = [self convertPointToBacking: local_pt];
+	// Squeak is upside down
+	return NSMakePoint(converted.x, -converted.y);
+}
+
+
 - (void)viewDidMoveToWindow {
 	if (self.squeakTrackingRectForCursor)
 		[self removeTrackingRect: self.squeakTrackingRectForCursor];
 	
-	self.squeakTrackingRectForCursor = [self addTrackingRect: [self bounds] owner: self userData:NULL assumeInside: NO];
+	self.squeakTrackingRectForCursor = [self addTrackingRect: [self sqScreenSize] owner: self userData:NULL assumeInside: NO];
 }
 
 - (void) updateTrackingAreas {
 	[super updateTrackingAreas];
 	[self removeTrackingRect: self.squeakTrackingRectForCursor];
-	self.squeakTrackingRectForCursor = [self addTrackingRect: [self bounds] owner: self userData:NULL assumeInside: NO];
+	self.squeakTrackingRectForCursor = [self addTrackingRect: [self sqScreenSize] owner: self userData:NULL assumeInside: NO];
 }
 
 - (void) viewWillStartLiveResize {
@@ -181,7 +200,8 @@
 	}
 }
 
--(void)setupOpenGL {	
+-(void)setupOpenGL {
+	NSRect r = [self convertRectToBacking: [self frame]];
 //	CGL_MACRO_DECLARE_VARIABLES();
 // Enable the multithreading
 	CGLContextObj ctx = [[self openGLContext] CGLContextObj];
@@ -201,8 +221,8 @@
 	glDisable(GL_FOG);
 	glDisable(GL_TEXTURE_2D);
 	glDisable(GL_DEPTH_TEST);
-	glDisable (GL_SCISSOR_TEST);
-    glDisable (GL_CULL_FACE);
+	glDisable(GL_SCISSOR_TEST);
+    glDisable(GL_CULL_FACE);
 	glStencilMask(0);
 	glPixelZoom(1.0,1.0);
 	
@@ -214,17 +234,17 @@
 	glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
 	glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
 	glTexParameteri(GL_TEXTURE_RECTANGLE_ARB, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
-	glPixelStorei( GL_UNPACK_ROW_LENGTH, self.frame.size.width );
+	glPixelStorei( GL_UNPACK_ROW_LENGTH, r.size.width );
 	GLuint dt = 1;
 	glDeleteTextures(1, &dt);
 	glBindTexture(GL_TEXTURE_RECTANGLE_ARB, 1);
 	syncNeeded = NO;
 }
 
-- (void)loadTexturesFrom: (void*) lastBitsIndex subRectangle: (NSRect) subRect { 
+- (void)loadTexturesFrom: (void*) lastBitsIndex subRectangle: (NSRect) subRect {
 //	CGL_MACRO_DECLARE_VARIABLES();
 	static void *previousLastBitsIndex=null;
-	NSRect r=[self frame];
+	NSRect r = [self convertRectToBacking: [self frame]];
 	if (!(previousLastBitsIndex == lastBitsIndex)) {
 		previousLastBitsIndex = lastBitsIndex;
 		glTextureRangeAPPLE(GL_TEXTURE_RECTANGLE_ARB, r.size.width*r.size.height*4,lastBitsIndex);		
@@ -233,7 +253,7 @@
 	glViewport( subRect.origin.x,subRect.origin.y, subRect.size.width,subRect.size.height );
 	char *subimg = ((char*)lastBitsIndex) + (unsigned int)(subRect.origin.x + (r.size.height-subRect.origin.y-subRect.size.height)*r.size.width)*4;
 	glTexImage2D( GL_TEXTURE_RECTANGLE_ARB, 0, GL_RGBA, subRect.size.width, subRect.size.height, 0, GL_BGRA, GL_UNSIGNED_INT_8_8_8_8_REV, subimg );
-	//	NSLog(@" draw %f %f %f %f",subRect.origin.x,subRect.origin.y,subRect.size.width,subRect.size.height);	
+//		NSLog(@" draw %f %f %f %f",subRect.origin.x,subRect.origin.y,subRect.size.width,subRect.size.height);
 }
 
 -(void)defineQuad:(NSRect)r
@@ -259,7 +279,7 @@
 //	CGL_MACRO_DECLARE_VARIABLES();
 	[[self openGLContext] update];
 	
-	rect = [self bounds];
+	rect = [self sqScreenSize];
 	
     glViewport(0, 0, rect.size.width, rect.size.height);
 	glPixelStorei( GL_UNPACK_ROW_LENGTH, rect.size.width );
@@ -288,8 +308,8 @@
 //	CGL_MACRO_DECLARE_VARIABLES();
 	[[self openGLContext] update];
 	
-	rect = [self bounds];
-	
+	rect = [self sqScreenSize];
+
 	glViewport(0, 0, rect.size.width, rect.size.height);
 	glPixelStorei( GL_UNPACK_ROW_LENGTH, rect.size.width );
 	glMatrixMode(GL_PROJECTION);
@@ -307,7 +327,7 @@
 
 -(void)drawRect:(NSRect)rect
 {
-//	NSLog(@" draw %f %f %f %f",rect.origin.x,rect.origin.y,rect.size.width,rect.size.height);
+//	NSLog(@"dr: draw %f %f %f %f",rect.origin.x,rect.origin.y,rect.size.width,rect.size.height);
 	NSOpenGLContext *oldContext = [NSOpenGLContext currentContext];
 	sqInt formObj = interpreterProxy->displayObject();
 	sqInt formPtrOop = interpreterProxy->fetchPointerofObject(0, formObj);	
@@ -352,10 +372,6 @@
 	[(sqSqueakOSXApplication *) gDelegateApp.squeakApplication recordMouseEvent: theEvent fromView: self];
 }
 
-- (void)scrollWheel:(NSEvent *)theEvent {
-	[(sqSqueakOSXApplication *) gDelegateApp.squeakApplication recordWheelEvent: theEvent fromView: self];
-}
-
 - (void)mouseUp:(NSEvent *)theEvent {
 	[(sqSqueakOSXApplication *) gDelegateApp.squeakApplication recordMouseEvent: theEvent fromView: self];
 }
@@ -378,7 +394,12 @@
 - (void)otherMouseDown:(NSEvent *)theEvent {
 	[(sqSqueakOSXApplication *) gDelegateApp.squeakApplication recordMouseEvent: theEvent fromView: self];
 }
- 
+
+- (void)scrollWheel:(NSEvent *)theEvent {
+	[(sqSqueakOSXApplication *) gDelegateApp.squeakApplication recordWheelEvent: theEvent fromView: self];
+}
+
+
 - (NSString *) dealWithOpenStepChars: (NSString *) openStep {
 	
 	unichar keyChar; 
@@ -714,7 +735,6 @@
 }
 
 - (void)  ioSetFullScreen: (sqInt) fullScreen {
-	
 	if ([self isInFullScreenMode] == YES && (fullScreen == 1)) 
 		return;
 	if ([self isInFullScreenMode] == NO && (fullScreen == 0))
@@ -723,6 +743,8 @@
 	if ([self isInFullScreenMode] == NO && (fullScreen == 1)) {
 		self.savedScreenBoundsAtTimeOfFullScreen = (NSRect) [self bounds];
 		NSDictionary* options = [NSDictionary dictionaryWithObjectsAndKeys:
+			[NSNumber numberWithBool:NO],
+			NSFullScreenModeAllScreens,
 			[NSNumber numberWithInt:
 				NSApplicationPresentationHideDock |
 				NSApplicationPresentationHideMenuBar ],
@@ -741,8 +763,4 @@
 	}
 }
 
-- (void) preDrawThelayers {
-}
-
-
 @end
Index: platforms/iOS/vm/OSX/sqSqueakOSXView.h
===================================================================
--- platforms/iOS/vm/OSX/sqSqueakOSXView.h	(revision 3687)
+++ platforms/iOS/vm/OSX/sqSqueakOSXView.h	(working copy)
@@ -47,4 +47,7 @@
 -(void)drawThelayers;
 -(void)drawImageUsingClip:(CGRect)clip;
 
+- (NSRect) sqScreenSize;
+- (NSPoint) sqMousePosition: (NSEvent*)theEvent;
+
 @end
\ No newline at end of file
Index: platforms/iOS/vm/iPhone/Classes/SqueakUIView.h
===================================================================
--- platforms/iOS/vm/iPhone/Classes/SqueakUIView.h	(revision 3687)
+++ platforms/iOS/vm/iPhone/Classes/SqueakUIView.h	(working copy)
@@ -53,6 +53,8 @@
     - (void) preDrawThelayers;
 	- (void) drawThelayers;
 	- (void) drawImageUsingClip: (CGRect) clip;
+	- (CGRect) sqScreenSize;
+	- (NSPoint) sqMousePosition: (NSEvent*)theEvent;
 	@property (nonatomic,assign) void *squeakTheDisplayBits;
     @property (nonatomic,strong) NSArray *arrowsNames;  // jdr
 @end
Index: platforms/iOS/vm/iPhone/Classes/SqueakUIView.m
===================================================================
--- platforms/iOS/vm/iPhone/Classes/SqueakUIView.m	(revision 3687)
+++ platforms/iOS/vm/iPhone/Classes/SqueakUIView.m	(working copy)
@@ -74,6 +74,14 @@
 - (void) drawImageUsingClip: (CGRect) clip {
 }
 
+- (CGRect) sqScreenSize {
+	return [self bounds];
+}
+
+- (NSPoint) sqMousePosition: (NSEvent*)theEvent {
+	return [self convertPoint: [theEvent locationInWindow] fromView:nil];
+}
+
 // Handles the start of a touch
 - (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
 {
